#include "stdafx.h"
#include "imgdemo.h"
#include "imgDlg.h"
#include "imgdll.h"

//
//	make sure all the controls have the values we want them to have
//

void CImgDlg::SetAllControls()
{
	CString txt;
	// sharpen
	txt.Format("%d", m_iSharpenLevel);
	m_sharpenLevelWnd.SetWindowText(txt);
	m_sharpenCheck.SetCheck(m_doSharpen);

	// blur
	txt.Format("%d", m_iBlurLevel);
	m_BlurLevelWnd.SetWindowText(txt);
	m_BlurCheck.SetCheck(m_doBlur);

	// median cut
	m_medianCutCheck.SetCheck(m_doMedianCut);

	// matrix
	txt.Format("%6.4f", m_fMatrix[8]);
	m_matrix8Wnd.SetWindowText(txt);
	txt.Format("%6.4f", m_fMatrix[7]);
	m_matrix7Wnd.SetWindowText(txt);
	txt.Format("%6.4f", m_fMatrix[6]);
	m_matrix6Wnd.SetWindowText(txt);
	txt.Format("%6.4f", m_fMatrix[5]);
	m_matrix5Wnd.SetWindowText(txt);
	txt.Format("%6.4f", m_fMatrix[4]);
	m_matrix4Wnd.SetWindowText(txt);
	txt.Format("%6.4f", m_fMatrix[3]);
	m_matrix3Wnd.SetWindowText(txt);
	txt.Format("%6.4f", m_fMatrix[2]);
	m_matrix2Wnd.SetWindowText(txt);
	txt.Format("%6.4f", m_fMatrix[1]);
	m_matrix1Wnd.SetWindowText(txt);
	txt.Format("%6.4f", m_fMatrix[0]);
	m_matrix0Wnd.SetWindowText(txt);

	m_matrixZeroCheck.SetCheck(m_bZero);
	m_matrixRedCheck.SetCheck(((m_MatrixChannelMask & CHRED) == CHRED));
	m_matrixGreenCheck.SetCheck(((m_MatrixChannelMask & CHGREEN) == CHGREEN));
	m_matrixBlueCheck.SetCheck(((m_MatrixChannelMask & CHBLUE) == CHBLUE));
	m_matrixOnCheck.SetCheck(m_doMatrix);
	m_matrixFeedbackCheck.SetCheck(m_bFeedback);

	txt.Format("%6.4f", m_fMatrixLevel);
	m_matrixLevelWnd.SetWindowText(txt);

	// lut
	m_LUTRedCheck.SetCheck(((m_LUTChannelMask & CHRED) == CHRED));
	m_LUTGreenCheck.SetCheck(((m_LUTChannelMask & CHGREEN) == CHGREEN));
	m_LUTBlueCheck.SetCheck(((m_LUTChannelMask & CHBLUE) == CHBLUE));
	CheckRadioButton(IDC_LINLUT, IDC_INVLUT, (m_bStepLUT ? IDC_LINLUT : IDC_INVLUT));

	// stuff
	m_grayCheck.SetCheck(m_doGray);
	m_rgbbgrCheck.SetCheck(m_doRGBBGR);
	m_flipCheck.SetCheck(m_doFlip);
	m_hFlipCheck.SetCheck(m_doHFlip);

	// quant
	m_quantCheck.SetCheck(m_doQuantize);
	txt.Format("%d",m_iQuantColors);
	m_quantColorsWnd.SetWindowText(txt);

	// eq
	m_histRedCheck.SetCheck(((m_EQChannelMask & CHRED) == CHRED));
	m_histGreenCheck.SetCheck(((m_EQChannelMask & CHGREEN) == CHGREEN));
	m_histBlueCheck.SetCheck(((m_EQChannelMask & CHBLUE) == CHBLUE));
	m_histCheck.SetCheck(m_doEQ);
	txt.Format("%d",m_iEQLowLevel);
	m_histLowWnd.SetWindowText(txt);
	txt.Format("%d",m_iEQHighLevel);
	m_histHighWnd.SetWindowText(txt);

	// quick rotate
	CheckRadioButton(IDC_ROTATE_NONE, IDC_ROTATE_270, IDC_ROTATE_NONE);


	CheckRadioButton(IDC_EQ_LUM, IDC_EQ_BLUE, IDC_EQ_LUM);
}

////////////////////////////////////////////////////////////////////////
// a thousand control handlers....

void CImgDlg::OnBlurCheck() 
{
	m_doBlur = m_BlurCheck.GetCheck();
	InvalidateAfterImage();
}

void CImgDlg::OnChangeBlurLevel() 
{
	CString txt;
	m_BlurLevelWnd.GetWindowText(txt);
	m_iBlurLevel=atoi(txt);

	InvalidateAfterImage();
}

////////////////////////////////////////////////////////////////////////

void CImgDlg::OnSharpenCheck() 
{
	m_doSharpen = m_sharpenCheck.GetCheck();
	InvalidateAfterImage();
}

void CImgDlg::OnChangeSharpenLevel() 
{
	CString txt;
	m_sharpenLevelWnd.GetWindowText(txt);
	m_iSharpenLevel=atoi(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnMedianCut() 
{
	m_doMedianCut = m_medianCutCheck.GetCheck();
	InvalidateAfterImage();
}



////////////////////////////////////////////////////////////////////////

void CImgDlg::OnFlip() 
{
	m_doFlip = m_flipCheck.GetCheck();
	InvalidateAfterImage();
}

////////////////////////////////////////////////////////////////////////

void CImgDlg::OnHorizflip() 
{
	m_doHFlip = m_hFlipCheck.GetCheck();
	InvalidateAfterImage();
}

////////////////////////////////////////////////////////////////////////

void CImgDlg::OnRgbbgr() 
{
	m_doRGBBGR = m_rgbbgrCheck.GetCheck();
	InvalidateAfterImage();
}

////////////////////////////////////////////////////////////////////////

void CImgDlg::OnGrayscale() 
{
	m_doGray = m_grayCheck.GetCheck();
	InvalidateAfterImage();
}


////////////////////////////////////////////////////////////////////////

void CImgDlg::OnLutcheck() 
{
	m_doLUT = m_LUTCheck.GetCheck();
	InvalidateAfterImage();
}

void CImgDlg::OnLutBlue() 
{
	BOOL check = m_LUTBlueCheck.GetCheck();
	if (check)
		m_LUTChannelMask = m_LUTChannelMask | CHBLUE;
	else 
		m_LUTChannelMask = m_LUTChannelMask ^ CHBLUE;

	InvalidateAfterImage();
}

void CImgDlg::OnLutGreen() 
{
	BOOL check = m_LUTGreenCheck.GetCheck();
	if (check)
		m_LUTChannelMask = m_LUTChannelMask | CHGREEN;
	else 
		m_LUTChannelMask = m_LUTChannelMask ^ CHGREEN;

	InvalidateAfterImage();
}

void CImgDlg::OnLutRed() 
{
	BOOL check = m_LUTRedCheck.GetCheck();
	if (check)
		m_LUTChannelMask = m_LUTChannelMask | CHRED;
	else 
		m_LUTChannelMask = m_LUTChannelMask ^ CHRED;

	InvalidateAfterImage();
}


void CImgDlg::OnInvlut() 
{
	CButton * pBut = (CButton *)GetDlgItem(IDC_INVLUT);
	m_bStepLUT=!(pBut->GetCheck());

	InvalidateAfterImage();
}

void CImgDlg::OnLinlut() 
{
	CButton * pBut = (CButton *)GetDlgItem(IDC_LINLUT);
	m_bStepLUT=(pBut->GetCheck());

	InvalidateAfterImage();
}

////////////////////////////////////////////////////////////////////////

void CImgDlg::OnHistRed() 
{
	BOOL check = m_histRedCheck.GetCheck();
	if (check)
		m_EQChannelMask = m_EQChannelMask  | CHRED;
	else 
		m_EQChannelMask  = m_EQChannelMask  ^ CHRED;

	InvalidateAfterImage();
}

void CImgDlg::OnHistBlue() 
{
	BOOL check = m_histBlueCheck.GetCheck();
	if (check)
		m_EQChannelMask = m_EQChannelMask  | CHBLUE;
	else 
		m_EQChannelMask  = m_EQChannelMask  ^ CHBLUE;

	InvalidateAfterImage();
}

void CImgDlg::OnHistGreen() 
{
	BOOL check = m_histGreenCheck.GetCheck();
	if (check)
		m_EQChannelMask = m_EQChannelMask  | CHGREEN;
	else 
		m_EQChannelMask  = m_EQChannelMask  ^ CHGREEN;

	InvalidateAfterImage();	
}

void CImgDlg::OnChangeHistHigh() 
{
	CString txt;
	m_histHighWnd.GetWindowText(txt);
	m_iEQHighLevel=atoi(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnChangeHistLow() 
{
	CString txt;
	m_histLowWnd.GetWindowText(txt);
	m_iEQLowLevel=atoi(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnHistcheck() 
{
	m_doEQ = m_histCheck.GetCheck();
	InvalidateAfterImage();
}


////////////////////////////////////////////////////////////////////////

void CImgDlg::OnRotate180() 
{
	m_quickRotationType = 1;
	InvalidateAfterImage();
}

void CImgDlg::OnRotate270() 
{
	m_quickRotationType = 2;
	InvalidateAfterImage();
}

void CImgDlg::OnRotate90() 
{
	m_quickRotationType = 0;
	InvalidateAfterImage();
}

void CImgDlg::OnRotateNone() 
{
	m_quickRotationType = -1;
	InvalidateAfterImage();
}

////////////////////////////////////////////////////////////////////////

void CImgDlg::OnMatrixOn() 
{
	m_doMatrix = m_matrixOnCheck.GetCheck();
	InvalidateAfterImage();
}

void CImgDlg::OnMatrixZero() 
{
	m_bZero = m_matrixZeroCheck.GetCheck();
	InvalidateAfterImage();
}


void CImgDlg::OnMatrixBlue() 
{
	BOOL check = m_matrixBlueCheck.GetCheck();
	if (check)
		m_MatrixChannelMask = m_MatrixChannelMask  | CHBLUE;
	else 
		m_MatrixChannelMask  = m_MatrixChannelMask  ^ CHBLUE;

	InvalidateAfterImage();
}

void CImgDlg::OnMatrixRed() 
{
	BOOL check = m_matrixRedCheck.GetCheck();
	if (check)
		m_MatrixChannelMask = m_MatrixChannelMask  | CHRED;
	else 
		m_MatrixChannelMask  = m_MatrixChannelMask  ^ CHRED;

	InvalidateAfterImage();
}

void CImgDlg::OnMatrixGreen() 
{
	BOOL check = m_matrixGreenCheck.GetCheck();
	if (check)
		m_MatrixChannelMask = m_MatrixChannelMask  | CHGREEN;
	else 
		m_MatrixChannelMask  = m_MatrixChannelMask  ^ CHGREEN;

	InvalidateAfterImage();
}

void CImgDlg::OnMatrixFeedback() 
{
	m_bFeedback =  m_matrixFeedbackCheck.GetCheck();
	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrixLevel() 
{
	CString txt;
	m_matrixLevelWnd.GetWindowText(txt);
	m_fMatrixLevel=atof(txt);
	
	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrix0() 
{
	CString txt;
	m_matrix0Wnd.GetWindowText(txt);
	m_fMatrix[0]=atof(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrix1() 
{
	CString txt;
	m_matrix1Wnd.GetWindowText(txt);
	m_fMatrix[1]=atof(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrix2() 
{
	CString txt;
	m_matrix2Wnd.GetWindowText(txt);
	m_fMatrix[2]=atof(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrix3() 
{
	CString txt;
	m_matrix3Wnd.GetWindowText(txt);
	m_fMatrix[3]=atof(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrix4() 
{
	CString txt;
	m_matrix4Wnd.GetWindowText(txt);
	m_fMatrix[4]=atof(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrix5() 
{
	CString txt;
	m_matrix5Wnd.GetWindowText(txt);
	m_fMatrix[5]=atof(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrix6() 
{
	CString txt;
	m_matrix6Wnd.GetWindowText(txt);
	m_fMatrix[6]=atof(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrix7() 
{
	CString txt;
	m_matrix7Wnd.GetWindowText(txt);
	m_fMatrix[7]=atof(txt);

	InvalidateAfterImage();
}

void CImgDlg::OnChangeMatrix8() 
{
	CString txt;
	m_matrix8Wnd.GetWindowText(txt);
	m_fMatrix[8]=atof(txt);

	InvalidateAfterImage();
}

////////////////////////////////////////////////////////////////////////



void CImgDlg::OnEqBlue() 
{
	m_EQGraphMask = CHBLUE;
	InvalidateHistogram();
}

void CImgDlg::OnEqGreen() 
{
	m_EQGraphMask = CHGREEN;
	InvalidateHistogram();
}

void CImgDlg::OnEqLum() 
{
	m_EQGraphMask = 0;
	InvalidateHistogram();
}

void CImgDlg::OnEqRed() 
{
	m_EQGraphMask = CHRED;
	InvalidateHistogram();
}

////////////////////////////////////////////////////////////////////////

void CImgDlg::OnQuantizeCheck() 
{
	m_doQuantize=m_quantCheck.GetCheck();	
	InvalidateAfterImage();
}



void CImgDlg::OnChangeQuantColors() 
{
	CString txt;
	m_quantColorsWnd.GetWindowText(txt);
	m_iQuantColors=atoi(txt);

	InvalidateAfterImage();
}
